
'---------------------------   -----------------------------------
  $regfile = "m328pdef.dat"
  $crystal = 18432000       ' 18.432 
  $framesize = 32
  $hwstack = 40
  $swstack = 16
  $baud = 230400    '1200     '2400     '4800     '9600     '19200     '38400     '57600     '115200
  Ucsr0a.1 = 1
'----------------------     -------------------------------------
  Config Adc = Single , Prescaler = 128 , Reference = Avcc
  On Adc __       'Nosave
'----------------------     ------------------------------
  Dim __word As Word
  Dim __single As Single
  Dim ___ As Byte
  Dim __str As String * 5
  Dim __lcd_str As String * 5
  Dim __(2) As Byte At __word Overlay
'-----------------    i2c  LCD RDX0154  -----------------------
  $lib "glcd-UC1601.lib"
  $lib "i2c_twi.lbx"       '        I2c  ,     I2c      
  Config Sda = Portc.4       '   Sda
  Config Scl = Portc.5       '   Scl
  Config Twi = 400000       '    I2c   
'  Config I2cdelay = 1       '    I2c   
  I2cinit           '   I2c
  I2cinit           '   I2c
  Waitms 50
  Config Graphlcd = 192x64sed       ', Rst = Portc.3  'Optional Hardware Reset
  Const Lcd_type = 3       '    LCD  RDX0xxx: 0 = RDX0032 or RDX0048; 1 = RDX0077; 2 = RDX0120; 3 = RDX0154
  Initlcd           '   I2c
  Waitms 50         '    LCD
  Cls
  Const Rotate_180 = 0       '   180, 1=Rotate 180, 0=Not Rotate
  Lcdcontrast 100   '  
  Setfont Font_6x8
  Lcdat 0 , 0 , ""
  Lcdat 4 , 0 , "_ "
'-------------------   TIMER0  TIMER2     ------------------
  Config Timer0 = Pwm , Compare A Pwm = Clear Up , Compare B Pwm = Clear Down , Prescale = 1       '1|8|64|256|1024
  Config Portd.5 = Output
  Config Portd.6 = Output

  Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Down , Prescale = 1       '1|8|64|256|1024
  Config Portb.1 = Output
  Config Portb.2 = Output

  Config Timer2 = Pwm , Compare A Pwm = Clear Up , Compare B Pwm = Clear Down , Prescale = 1       '1|8|64|256|1024
  Config Portb.3 = Output
  Config Portd.3 = Output
'----------------------------   USART  --------------------------------
  On Urxc __uart       '           UART
  On Udre __uart_       '            UART
  On Utxc __uart_
'-----------------------     -----------------------------
  Dim _ As Byte
  Dim _ As Word
  Dim __uart As String * 20
  Dim ___uart As Byte
  Dim __uart_ As Byte
  Dim ____uart As Byte
  Dim __uart_byte(21) As Byte
  Dim __uart_str As String * 20 At __uart_byte(1) Overlay
  __uart_str = ""
'--------------------       --------------------
'--------------------       --------------------
  Enable Adc
  Enable Urxc
  Enable Utxc
  Enable Timer0
  Enable Timer1
  Enable Timer2
'--------------------       ------------------------
  Enable Interrupts
'  Power Adcnoise
'===============================================================================
  _:

'-----------     USART  6    -----------
     Incr Ocr0a
     Decr Ocr0b

     Incr Ocr1al
     Decr Ocr1bl

     Incr Ocr2a
     Decr Ocr2b


      If ____uart <> 0 Then
          If __uart = "" Then
              Incr _
              Setfont Font_seg_10x16
              Lcdat 1 , 0 , _
              Disable Urxc
              __uart = ""
              Enable Udre
              ____uart = 0
              Goto _
          End If
      End If



    If ___ <> 0 Then
        __single = __word * 0.0488
        __str = Fusing(__single , "&.&")
        __lcd_str = Format(__str , " 0")

        Setfont Font_seg_10x16
        Lcdat 5 , 0 , __lcd_str
        ___ = 0
        Goto _
    End If



    If __uart_ <> 0 And ____uart = 0 Then
        Start Adc
        Power Adcnoise
        __uart_ = 0
    End If



  Goto _
 End

'===============================================================================
  __uart_:
'-------------------------------------------------------------------------------
    Incr _

    If __uart_byte(_) <> 0 Then
        Udr = __uart_byte(_)
      Else
        Udr = 13
        _ = 0
        Disable Udre       '      UART
    End If
'-------------------------------------------------------------------------------
  Return
'===============================================================================


'===============================================================================
  __uart:       '   1  = 46 
'-------------------------------------------------------------------------------
    ___uart = Udr       '     USART

    If ___uart <> 13 Then       ' ,      "Enter"
        __uart = __uart + Chr(___uart)       '  ,        USART 
      Else
        Disable Urxc
        ____uart = 1       '    "Enter",     1. "Enter"-  
    End If
'-------------------------------------------------------------------------------
  Return
'===============================================================================


'===============================================================================
  __uart_:
'-------------------------------------------------------------------------------
    __uart_ = 1
    Enable Urxc
'-------------------------------------------------------------------------------
  Return
'===============================================================================


'===============================================================================
  __:
'-------------------------------------------------------------------------------
'  ,    
'    !Push R26
'    !Push R27
'------  ,    ---------------

    !in R26 , adcl
    !in R27 , adch

    !sts {__(1)} , R26
    !sts {__(2)} , R27

    !ldi R26 , 1
    !sts {___} , R26

' ,    
'    !pop R27
'    !pop R26
'    !reti
'-------------------------------------------------------------------------------
  Return
'===============================================================================



  $include "Font_6x8.font"
  $include "Font_Seg_10x16.font"